From 3cf9e7bf13e5f0f364aecf0913e09d704e9688d2 Mon Sep 17 00:00:00 2001
From: Anatol Pomozov <anatol.pomozov@gmail.com>
Date: Mon, 25 Nov 2013 17:33:25 -0800
Subject: [PATCH] Update rethinkdb to v8 API version 3.21

Signed-off-by: Anatol Pomozov <anatol.pomozov@gmail.com>
---
 src/extproc/js_job.cc | 15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

diff --git a/src/extproc/js_job.cc b/src/extproc/js_job.cc
index 984aea0..3ee0533 100644
--- a/src/extproc/js_job.cc
+++ b/src/extproc/js_job.cc
@@ -66,6 +66,7 @@ class js_context_t {
     v8::Persistent<v8::Context> context;
 #else
     js_context_t() :
+        local_scope(v8::Isolate::GetCurrent()),
         context(v8::Context::New(v8::Isolate::GetCurrent())),
         scope(context) { }
 
@@ -219,7 +220,7 @@ js_result_t js_env_t::eval(const std::string &source) {
     js_result_t result("");
     std::string *errmsg = boost::get<std::string>(&result);
 
-    v8::HandleScope handle_scope;
+    v8::HandleScope handle_scope(v8::Isolate::GetCurrent());
 
     // TODO: use an "external resource" to avoid copy?
     v8::Handle<v8::String> src = v8::String::New(source.data(), source.size());
@@ -290,7 +291,7 @@ js_id_t js_env_t::remember_value(const v8::Handle<v8::Value> &value) {
                                   const std::vector<counted_t<const ql::datum_t> > &args,
                                   std::string *errmsg) {
     v8::TryCatch try_catch;
-    v8::HandleScope scope;
+    v8::HandleScope scope(v8::Isolate::GetCurrent());
 
     // Construct receiver object.
     v8::Handle<v8::Object> obj = v8::Object::New();
@@ -320,7 +321,7 @@ js_result_t js_env_t::call(js_id_t id,
     const boost::shared_ptr<v8::Persistent<v8::Value> > found_value = find_value(id);
     guarantee(!found_value->IsEmpty());
 
-    v8::HandleScope handle_scope;
+    v8::HandleScope handle_scope(v8::Isolate::GetCurrent());
 
     // Construct local handle from persistent handle
 
@@ -367,7 +368,7 @@ void js_env_t::release(js_id_t id) {
     --recursion_limit;
 
     // TODO: should we handle BooleanObject, NumberObject, StringObject?
-    v8::HandleScope handle_scope;
+    v8::HandleScope handle_scope(v8::Isolate::GetCurrent());
 
     if (value->IsString()) {
         v8::Handle<v8::String> string = value->ToString();
@@ -471,7 +472,7 @@ void js_env_t::release(js_id_t id) {
     guarantee(!value.IsEmpty());
     guarantee(errmsg != NULL);
 
-    v8::HandleScope handle_scope;
+    v8::HandleScope handle_scope(v8::Isolate::GetCurrent());
     errmsg->assign("Unknown error when converting to ql::datum_t.");
 
     return js_make_datum(value, TO_JSON_RECURSION_LIMIT, errmsg);
@@ -497,7 +498,7 @@ void js_env_t::release(js_id_t id) {
         const std::vector<counted_t<const ql::datum_t> > &source_array = datum->as_array();
 
         for (size_t i = 0; i < source_array.size(); ++i) {
-            v8::HandleScope scope;
+            v8::HandleScope scope(v8::Isolate::GetCurrent());
             v8::Handle<v8::Value> val = js_from_datum(source_array[i]);
             guarantee(!val.IsEmpty());
             array->Set(i, val);
@@ -515,7 +516,7 @@ void js_env_t::release(js_id_t id) {
             const std::map<std::string, counted_t<const ql::datum_t> > &source_map = datum->as_object();
 
             for (auto it = source_map.begin(); it != source_map.end(); ++it) {
-                v8::HandleScope scope;
+                v8::HandleScope scope(v8::Isolate::GetCurrent());
                 v8::Handle<v8::Value> key = v8::String::New(it->first.c_str());
                 v8::Handle<v8::Value> val = js_from_datum(it->second);
                 guarantee(!key.IsEmpty() && !val.IsEmpty());
-- 
1.8.5-rc3

